//
// TxPacket/RxPacketgID̕ύXsĂ݂
//
// EDLL̈ÖٓIȃNgp
//

#include <stdio.h>
#include <stdint.h>
#include "krslib.h"
#include "krsmemmap.h"

// }N`
#define COMPORT     "\\\\.\\COM9"
#define BAUDRATE    115200
#define TIMEOUT     100

// ID̓ǂݏopPbgeXg
//  1̂ݐڑ̎
bool readid (TDeviceID hdev, uint8_t *detectid) {
  uint32_t      len;
  bool          result = false;
  const uint8_t tx[3] = {0, 0, 0};
  uint8_t       rx[1];
  const uint8_t reqid = 31;

  // IDR}h($E0|$1F,$00,$00,$00,$00)𑗐M
  if (KRS_TxPacket (hdev, reqid, CMD_ID, (uint8_t *)tx, 3, NULL)) {
    // 1bytẻM
    if (KRS_RxPacket (hdev, (uint8_t *)rx, 1, &len, 100, NULL)) {
      if ((rx[0] >> 5) == CMD_ID) {
        if (detectid != NULL) {
          *detectid = rx[0] & 0x1f;
          result = true;
        }
      }
    }
  }
  Sleep (5);  // IDR}h̃pPbgɊԂƃG[ɂȂ
  return result;
}

// ID̏݃pPbgeXg
//  1̂ݐڑ̎
bool changeid (TDeviceID hdev, uint8_t old_id, uint8_t new_id) {
  uint32_t      len;
  bool          result = false;
  const uint8_t tx[3] = {1, 1, 1};
  uint8_t       rx[1];
  uint8_t       detectid;

  // old_iďo
  if (readid (hdev, &detectid)) {
    if ((detectid == old_id) && (old_id != new_id)) {
      // IDR}h($E0|new_id,$01,$01,$01)𑗐M
      if (KRS_TxPacket (hdev, new_id, CMD_ID, (uint8_t *)tx, 3, NULL)) {
        // 1bytẻM
        if (KRS_RxPacket (hdev, rx, 1, &len, 100, NULL)) {
          result = (rx[0] == ((CMD_ID << 5) | new_id));
        }
      }
      Sleep (5);  // IDR}h̃pPbgɊԂƃG[ɂȂ
    }
  }
  return result;
}

void main (void) {
  TDeviceID   dev;
  int         s_id, d_id;

  // R}h[vobNI/F(Dual USB A_v^[)̎ɂtruew
  // BTE068ł̓[vobN̓n[hIɔj邽falsew
  KRS_SetEchoCancel (false);

  if ((dev = KRS_OpenPort (COMPORT, BAUDRATE))) {
    printf ("Now ID=");
    scanf("%d", &s_id);

    printf ("New ID=");
    scanf("%d", &d_id);

    printf("change id %d -> %d", s_id, d_id);
    if (changeid (dev, s_id, d_id)) printf (" OK\n");
    else printf (" NG\n");

    KRS_ClosePort (dev);
  } else {
    printf ("Open error\n");
  }
  printf ("Fin\n");
  getchar ();
  getchar ();
}
